src/website/airspace_sectors/__init__.py
from .blueprint import bp

src/website/airspace_sectors/blueprint.py
import os
from flask import Blueprint, render_template, request, redirect, url_for, current_app as app
from functools import partial
from pymongo import MongoClient
from uuid import uuid4, UUID

from src.kernel.messages import MessageBuilder

from src.airspace_sectors_service import LPPC, LPPO
from src.airspace_sectors_service import RivCommandHandlers
from src.airspace_sectors_service import CriarSector, AlterarFrequenciaSector

from .model import ReadModel, ReadFacade

RivCommandHandlers.register(app.bus, app.store)
ReadModel.register(app.bus, app.db)
_read = ReadFacade(app.db)
bp = Blueprint('airspace_sectors', __name__, template_folder='templates')

@bp.route('/<riv_id>')
def riv(riv_id):
    model = _read.riv_view(UUID(riv_id))
    return render_template('sectors/riv.html', **model)

@bp.route('/<riv_id>/criar_sector', methods=['POST'])
def criar_sector(riv_id):
    payl = request.form

    callsign = f'{payl["callsign"].upper()}_{payl["posicao"]}'
    cmd = MessageBuilder() \
        .aggregate(UUID(riv_id), int(payl['riv_version'])) \
        .type(CriarSector) \
        .kwargs(
            sector_id=uuid4(),
            nome=payl['nome'].title(),
            callsign=callsign,
            posicao=payl['posicao'],
            frequencia=float(payl['frequencia']),
        ) \
        .build()
    app.bus.send(cmd)

    return redirect(url_for('airspace_sectors.riv', riv_id=riv_id))

@bp.route('/<riv_id>/sectors/<sector_id>/editar', methods=['POST'])
def editar_sector(riv_id, sector_id):
    rq = MessageBuilder() \
        .aggregate(
            UUID(riv_id),
            int(request.form['riv_version']),
        ) \
        .type(AlterarFrequenciaSector) \
        .args(UUID(sector_id), float(request.form['frequencia']))
    app.bus.send(rq.build())
    return redirect(url_for('airspace_sectors.riv', riv_id=riv_id))

src/website/airspace_sectors/templates/sectors/riv.html
{% extends 'dashboard/base.html' %}

{% block scripts %}
  {{super()}}
  <script src="{{ url_for('static', filename='js/jquery.dataTables.min.js') }}"></script>
  <script src="{{ url_for('static', filename='js/dataTables.bootstrap4.min.js') }}"></script>
  <script src="{{ url_for('static', filename='js/datatables.js') }}"></script>

  <script type="application/javascript">
    function posicaoAtcChanged() {
      $('#lblCallsignSuffix').html(`_${$('#cmbPosicaoAtc').val()}`);
    }
  </script>
{% endblock %}

{% block page_content %}

<div class="container">
  <h1 class="m-0 font-weight-bold text-primary">Sectors List</h1>

  <div class="table-responsive">
    <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
      <tfoot><tr></tr></tfoot>

      <thead><tr><th>Name</th><th>ICAO</th><th>Position</th><th>Frequency</th><th></th></tr></thead>

      <tbody>
        {% for sector in sectores %}
          <tr>

            <!-- sector list item -->
            <form action="{{ url_for('airspace_sectors.editar_sector', riv_id=riv.id, sector_id=sector.id) }}" method="post">
              <input type="hidden" name="riv.id" value="{{ riv.id }}">
              <input type="hidden" name="riv_version" value="{{ riv.version }}">
              <td class="align-middle">{{ sector.nome }}</td>
              <td class="align-middle">{{ sector.callsign }}</td>
              <td class="align-middle">{{ sector.posicao }}</td>
              <td class="align-middle">
                <input
                  type="number"
                  name="frequencia"
                  class="form-control"
                  placeholder="118.000"
                  step="0.005"
                  max="137.000"
                  min="118.000"
                  value="{{sector.frequencia}}"
                  required>
              </td>
              <td class="align-middle">
                <button
                  type="submit"
                  class="btn btn-success">Update</button>
              </td>
            </form><!-- sector list item -->
              
          </tr>
        {% endfor %}
      </tbody>

      <tfoot>
        <tr><th>Name</th><th>ICAO</th><th>Position</th><th>Frequency</th><th></th></tr>
        <tr>  
          <!-- new sector form -->
          <form action="{{ url_for('airspace_sectors.criar_sector', riv_id=riv.id) }}" method="post">
            <input type="hidden" name="riv.id" value="{{ riv.id }}">
            <input type="hidden" name="riv_version" value="{{ riv.version }}">
            <td>
              <input placeholder="Nome" name="nome" class="form-control" required>
            </td>
            <td>
              <div class="input-group mb-3">
                <input
                  name="callsign"
                  placeholder="Callsign"
                  class="form-control"
                  style="text-transform:uppercase"
                  minlength="4"
                  maxlength="6"
                  required>
                <div class="input-group-append">
                  <span class="input-group-text" id="lblCallsignSuffix">_{{ posicoes[0].value }}</span>
                </div>
              </div>
            </td>
            <td>
              <select id="cmbPosicaoAtc" name="posicao" class="form-control" onchange="posicaoAtcChanged(this);" required>
                {% for posicao in posicoes %}
                  <option value="{{ posicao.key }}">{{ posicao.value }}</option>
                {% endfor %}
              </select>
            </td>
            <td>
              <input
                type="number"
                name="frequencia"
                class="form-control"
                placeholder="118.100"
                step="0.005"
                max="137.000"
                min="118.000"
                required>
            </td>
            <td>
              <button
                type="submit"
                class="btn btn-success">Add</button>
            </td>
          </form><!-- new sector form -->
        </tr>
      </tfoot>

    </table>
  </div>


</div>
{% endblock %}